﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;



namespace PDFXEditor
{


    public partial class MainFrm : Form
    {
        public PDFXEdit.IPXS_Inst pxsInst = null;
        public PDFXEdit.IPXC_Inst pxcInst = null;
        public PDFXEdit.IUIX_Inst uiInst = null;
        public PDFXEdit.IAFS_Inst fsInst = null;
        public PDFXEdit.IAUX_Inst auxInst = null;
        DrawPagesCallback _dPClbk = null;

        EditorIDS _editorIDS = null;
        string _settingsFile;
        IntPtr _isActive = (IntPtr)0;
        IntPtr _isTrial = (IntPtr)0;
        IntPtr _isLimit = (IntPtr)0;

        static class NativeMethods
        {
            [DllImport("kernel32.dll")]
            public static extern IntPtr LoadLibrary(string dllToLoad);
            [DllImport("kernel32.dll")]
            public static extern IntPtr GetProcAddress(IntPtr hModule, string procedureName);
            [DllImport("kernel32.dll")]
            public static extern bool FreeLibrary(IntPtr hModule);
        }

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        private delegate int GetLicenseStatus(out IntPtr isActive, out IntPtr isTrial, out IntPtr isLimited, [MarshalAs(UnmanagedType.BStr)] string strProgramData);

       

        public partial class UIEventMon : PDFXEdit.IUIX_EventMonitor
        {
            MainFrm _form;
            bool _registered = false;
            public  UIEventMon(MainFrm form)
            {
                _form = form;
            }
            public void OnEventMonitor(PDFXEdit.IUIX_Obj pTarget, PDFXEdit.IUIX_Event pEvent)
            {
                
               /* {
                    if (_form.pdfCtl.Doc != null && !_registered)
                    {
                        _form.pdfCtl.Doc.ActiveView.PagesView.RegisterDrawCallback(PDFXEdit.PXV_PagesViewDrawStage.PXV_PagesViewDraw_Foreground, _form._dPClbk);
                        _registered = true;
                    }
                }
                
                if( pEvent.Code == (int)PDFXEdit.UIX_EventCodes.e_BeforeDestroy )
                {
                    if(_form.pdfCtl.Doc != null && _registered )
                    {
                        _form.pdfCtl.Doc.ActiveView.PagesView.UnregisterDrawCallback(PDFXEdit.PXV_PagesViewDrawStage.PXV_PagesViewDraw_Foreground, _form._dPClbk);
                        _registered = false;
                    }
                }*/
                
            }
        }

        public UIEventMon _uiEventMon = null;

        public MainFrm()
        {
            this.Icon = Properties.Resources.PDFXEdit_128;
            InitializeComponent();
            InitializeControl();
        }
        private void MainEditorForm_Load(object sender, EventArgs e)
        {
            IntPtr pDll = NativeMethods.LoadLibrary("OCPCloudLicense.dll");
            if (pDll != null && pDll!=(IntPtr)0)
            {
                 IntPtr pAddressOfFunctionToCall = NativeMethods.GetProcAddress(pDll, "GetLicenseStatus");
                 GetLicenseStatus getLicenseStatus = (GetLicenseStatus)Marshal.GetDelegateForFunctionPointer(pAddressOfFunctionToCall, typeof(GetLicenseStatus));

               string path = Application.CommonAppDataPath;
               string appName = Application.ProductName;

               path = path.Substring(0, path.IndexOf(appName));
               int result = getLicenseStatus(out _isActive, out _isTrial, out _isLimit, path.ToString());
               if (result < 0 || _isActive == (IntPtr)0)
               {
                   MessageBox.Show(Properties.Resources.IDS_LICENSE_INVALID);
                   Application.Exit();
                   return;
               }
            }
        }

        private void InitializeControl()
        {
            _settingsFile = Application.StartupPath + "\\Settings.dat";
            PDFXEdit.PXV_Inst Inst = new PDFXEdit.PXV_Inst();
            uiInst = (PDFXEdit.IUIX_Inst)pdfCtl.Inst.GetExtension("UIX");
            fsInst = (PDFXEdit.IAFS_Inst)pdfCtl.Inst.GetExtension("AFS");
            auxInst = (PDFXEdit.IAUX_Inst)pdfCtl.Inst.GetExtension("AUX");
            pxsInst = (PDFXEdit.IPXS_Inst)pdfCtl.Inst.GetExtension("PXS");
            pxcInst = (PDFXEdit.IPXC_Inst)pdfCtl.Inst.GetExtension("PXC");

            PDFXEdit.IString prefsPathStr = null;
            PDFXEdit.IString histFileStr = null;
            PDFXEdit.IString histThumbsFileStr = null;

            if (_settingsFile.Length != 0)
                prefsPathStr = Inst.CreateString(_settingsFile);
            _editorIDS = new EditorIDS(); 
            _editorIDS.InitIDS(pdfCtl);
           /* if (histFile.Length != 0)
            {
                histFileStr = Inst.CreateString(histFile);
                histThumbsFileStr = Inst.CreateString(histThumbsFile);
            }*/
            Inst.Init(null, License.getLicense(), prefsPathStr, null/*histFileStr*/, /*histThumbsFileStr*/null);
            Inst = null;
            pdfCtl.VisibleCmdPanes = (uint)PDFXEdit.PXV_VisibleCmdPanes.PXV_VisibleCmdPanes_All;
            RegisterEvents(true);
  	    	//_uiEventMon = new UIEventMon(this);
      		//uiInst.CurrentThreadCtx.RegisterEventMonitor(_uiEventMon);
            if (_isTrial!= (IntPtr)0)
            {
               // IDS id = IDS._op_document_addWatermarks;
                //cbOpers.Items.Add(new OperationDemo(OpId2DispName(id), _editorIDS.nIDS[(int)id], OpId2Form(id), (uint)DemoFlags.Input_Doc));
            }
            makeReadonly(true);
        }
        private void makeReadonly(bool bReadonly)
        {
            string[] cmds = { "cmd.save", "cmd.saveAs", "cmd.saveCopyAs", "cmd.SaveAll", "cmd.saveToComp", "cmd.saveTo", "cmd.saveUnrestricted","cmd.sendByEmail", "cmd.sendByEmailZip" };
            foreach (string sCmd in cmds)
            {
                PDFXEdit.IUIX_Cmd cmd = uiInst.CmdManager.Cmds.Find(sCmd);
                if (cmd!=null)
                    cmd.Offline = bReadonly;
            }
            //_dPClbk = new DrawPagesCallback(auxInst, uiInst);
           
        }
        private void PlaceWatermark(PDFXEdit.IPXC_Document Doc, PDFXEdit.IPXC_Inst Inst)
        {
            //PDFXEdit.IAUX_Inst aInst = (PDFXEdit.IAUX_Inst)Inst.GetExtension("AUX");
            PDFXEdit.IBitSet bs = auxInst.CreateBitSet(Doc.Pages.Count);
            PDFXEdit.IPXC_WatermarkParams wp = Inst.CreateWatermarkParams();
            bs.Set(0, Doc.Pages.Count); 
            wp.Text = Properties.Resources.IDS_WATERMARK_TEXT;
            wp.FontSize = Convert.ToSingle(50);
            Doc.PlaceWatermark(bs, wp);
        }

        public bool IsErrCode(int nCode)
        {
            return (nCode < 0);
        }
        private void RegisterEvents(bool bRegister)
        {
            if( _editorIDS != null )
            for (EditorIDS.IDS i = EditorIDS.IDS._e_begin_ + 1; i < EditorIDS.IDS._e_end_; i++)
                pdfCtl.EnableEventListening2(_editorIDS.nIDS[(int)i], bRegister);
             int id = pdfCtl.Inst.Str2ID("e.document.beforeClose");
             pdfCtl.EnableEventListening2(id, bRegister);

        }
        public void ShowErrMsg(int nErr)
        {
            if (!IsErrCode(nErr) || (auxInst == null) || auxInst.IsUserBreak(nErr))
                return;

            string err = auxInst.FormatHRESULT(nErr);
            if (err.Length == 0)
                return;
            int flags = (int)(PDFXEdit.UIX_MsgBoxStyleFlags.UIX_MsgBox_IconError | PDFXEdit.UIX_MsgBoxStyleFlags.UIX_MsgBox_Close | PDFXEdit.UIX_MsgBoxStyleFlags.UIX_MsgBox_AppModal);
            pdfCtl.Inst.ShowMsgBox(err, "", "", (uint)Handle, flags);
        }

        private void MainEditorForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            RegisterEvents(false);

            // unregister UI-events demo-monitor
            if (_uiEventMon != null)
            {
                uiInst.CurrentThreadCtx.UnregisterEventMonitor(_uiEventMon);
                _uiEventMon = null;
            }

            uiInst = null;
            fsInst = null;
            auxInst = null;
            pxsInst = null;
            pxcInst = null;

            if (_settingsFile.Length != 0)
            {
                try
                {
                    pdfCtl.Inst.SaveUserSettings(pdfCtl.Inst.CreateString(_settingsFile));
                }
                catch { }
            }
            pdfCtl.Inst.Shutdown();
        }
        private PDFXEdit.IPXV_Document _doc = null;
        private void pdfCtl_OnEvent(object sender, AxPDFXEdit._IPXV_ControlEvents_OnEventEvent e)
        {
            try
            {
                if (e.nEventID == pdfCtl.Inst.Str2ID("e.document.beforeClose"))
                {
                    if (_dPClbk != null)
                        pdfCtl.Doc.ActiveView.PagesView.UnregisterDrawCallback(PDFXEdit.PXV_PagesViewDrawStage.PXV_PagesViewDraw_Foreground, _dPClbk);
                }

                /*if (e.nEventID == _editorIDS.nIDS[(int)IDS.e_activeDocChanged])
                {

                    if (_doc != null)
                        _doc.ActiveView.PagesView.UnregisterDrawCallback(PDFXEdit.PXV_PagesViewDrawStage.PXV_PagesViewDraw_Foreground, _dPClbk);
                   
                    if(this.pdfCtl.Doc!=null )
                        this.pdfCtl.Doc.ActiveView.PagesView.RegisterDrawCallback(PDFXEdit.PXV_PagesViewDrawStage.PXV_PagesViewDraw_Foreground, _dPClbk);
                    
                    _doc = this.pdfCtl.Doc;
                }
                int id = pdfCtl.Inst.Str2ID("e.document.beforeClose");

                if (e.nEventID == id)
                {
                    this.pdfCtl.Doc.ActiveView.PagesView.UnregisterDrawCallback(PDFXEdit.PXV_PagesViewDrawStage.PXV_PagesViewDraw_Foreground, _dPClbk);
                    _doc = null;
                } */
            }
            catch (Exception ex)
            {
                return;
            }
        }

        private void drawRectangleOnPageToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (_dPClbk == null)
            {
                _dPClbk = new DrawPagesCallback(auxInst, uiInst);
                //Registering callback at the needed document's pages view
                pdfCtl.Doc.ActiveView.PagesView.RegisterDrawCallback(PDFXEdit.PXV_PagesViewDrawStage.PXV_PagesViewDraw_Foreground, _dPClbk);
                //!!! Do not forget to unregister it when document closes !!!
            }
        }

    }
}
